import requests, chardet
from lxml import etree
from urllib import parse
class mkzlz:
    def __init__(self):
        self.headers = {
            'Referer': 'https://www.baidu.com/',
            'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8',
            'Content-Type': 'text/html; charset=UTF-8',
            'User-Agent':'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36'
        }
        self.charset = 'utf-8'  # 默认编码格式
        self.pagemax = '75' # 尾页

        self.book_name = ''  # 漫画名
        self.nick_name = '漫画搜'  # 漫画别名
        self.tags = ''  # 分类，多个分类用|隔开
        self.author = ''  # 作者名字
        self.src = ''  # 采集源
        self.cover_url = ''  # 封面图远程地址
        self.area_id = ''  # 地区id
        self.summary = ''  # 漫画简介
        self.end = 0
        self.chapter_name = ''

    def html(self, url):
        req = requests.get(url, headers=self.headers)
        html = req.content
        self.charset = chardet.detect(html)['encoding']
        return html.decode(self.charset)

    # 取链接漫画页面数据
    def lzdata(self, url):
        html = self.html(url)
        xphtml = etree.HTML(html)
        mhurldata = xphtml.xpath('//div/div/p[@class="comic__title"]/a/@href')  # 漫画地址
        for i in mhurldata:
            url = parse.urljoin(url, i)
            html = self.html(url)
            xphtml = etree.HTML(html)
            mhurl = xphtml.xpath('//div[@class="chapter__list clearfix"]/ul/li/a/@data-hreflink')  # 漫画地址
            mhurl.reverse()
            self.book_name = xphtml.xpath('//p[@class="comic-title j-comic-title"]/text()')[0]  # 漫画名
            self.nick_name = '漫画搜'  # 漫画别名
            self.tags = xphtml.xpath('//div/span[@class="text"]/b/text()')[0].replace(' ', '|')  # 分类，多个分类用|隔开
            self.author = xphtml.xpath('//div[@class="comic-author"]/span/a/text()')[0]  # 作者名字
            self.src = url  # 采集源
            self.cover_url = xphtml.xpath('//div[@class="de-info__cover"]/img/@data-src')[0]  # 封面图远程地址
            self.area_id = ''  # 地区id
            self.summary = xphtml.xpath('//p[@class="intro-total"]/text()')[0]  # 漫画简介
            if xphtml.xpath('//div[@class="de-chapter__title"]/span/text()')[0] == '完结':
                self.end = 1  # 连载
            else:
                self.end = 0  # 连载
            for j in mhurl:
                print('\t' + j)
                url = parse.urljoin(url, j)
                html = self.html(url)
                xphtml = etree.HTML(html)
                imgurl = xphtml.xpath('//div/img/@data-src')  # 获取章节图片
                self.chapter_name = xphtml.xpath('//h1[@class="comic-title"]/a/text()')[0]  # 章节名
                self.upurl(imgurl)

    def upurl(self, imgdata):
        upurl = 'http://你的域名/api/write/save'
        datas = ''
        for i in imgdata:
            i = '<img src="' + i + '">'
            datas = datas + i
        print(datas)
        data = {
            'book_name': self.book_name,
            'nick_name': self.nick_name,
            'tags': self.tags,
            'author': self.author,
            'src': self.src,
            'end': self.end,
            'cover_url': self.cover_url,
            'chapter_name': self.chapter_name,
            'area_id': self.area_id,
            'images': datas,
            'api_key': 'api密钥',
            'summary': self.summary
        }
        requests.post(upurl, data=data, headers=self.headers)

if __name__ == '__main__':
    mkz = mkzlz()
    for i in range(1,145):
        mkz.lzdata('https://www.mkzhan.com/category/?page=' + str(i))
